unit Mxcfg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  sysutils, StdCtrls, ExtCtrls, oomisc, jmmutil, ComCtrls;

type
  TComCfgDlg = class(TForm)
    Panel1: TPanel;
    Comports: TRadioGroup;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    TraceCB: TCheckBox;
    CLSCB: TCheckBox;
    HandShakeRG: TRadioGroup;
    BaudRG: TRadioGroup;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    NumPort : array[0..32] of integer;
  public
  end;

var
  ComCfgDlg: TComCfgDlg;

implementation

uses mxMain;

{$R *.DFM}


procedure TComCfgDlg.FormActivate(Sender: TObject);
var i : integer;
begin
    CLSCB.checked := OscilloForm.withCLS;
    HandshakeRG.itemIndex := ord(OscilloForm.handShake);
    case OscilloForm.voieSerie.baud of
          9600 : BaudRG.itemIndex := 0;
          19200 : BaudRG.itemIndex := 1;
          38400 : BaudRG.itemIndex := 2;
          57600 : BaudRG.itemIndex := 3;
          else BaudRG.itemIndex := 0;
    end;
    ComPorts.items.clear;
    for i := 1 to MaxComHandles do
        if IsPortAvailable(i) then begin
           NumPort[ComPorts.items.count] := i;
           ComPorts.Items.Add('COM'+IntToStr(i));
           if i=OscilloForm.voieSerie.ComNumber then
              ComPorts.itemIndex := ComPorts.Items.count-1;
        end;
    if ComPorts.itemIndex<0 then ComPorts.itemIndex := 0;
end;

procedure TComCfgDlg.OKBtnClick(Sender: TObject);
begin with OscilloForm do begin
    voieSerie.ComNumber := NumPort[ComCfgDlg.ComPorts.itemIndex];
    withCLS := clsCB.checked;
    handShake := ThandShake(HandshakeRG.itemIndex);
    case BaudRG.itemIndex of
             0 : voieSerie.Baud := 9600;
             1 : voieSerie.Baud := 19200;
             2 : voieSerie.Baud := 38400;
             3 : voieSerie.Baud := 57600;
             else voieSerie.Baud := 9600;
    end;
end end;

end.
