unit Mxdde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, FileCtrl, registry,
  jmmUtil, mxGraphe, ComCtrls, clipbrd, shellApi, math;

type
  Tenvoi = (eAdd,eLoad,ePlus,eAddCol,eFocus);
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    debutOsc,finOsc : integer;
    premiereFois : boolean;
    procedure AjouteConst(var donnees : tstringList);
  public
      procedure Execute(Ordre : Tenvoi);
      procedure EnvoieDonneesOsc(DDE,UnePeriode : boolean);
      procedure AjouteDonneesOscillo;
      procedure EnvoieDonneesMult(DDE : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

uses mxMain, MxGrapheMult, Mxmult, MXconst;

{$R *.DFM}

procedure TFormDDE.Execute(Ordre : Tenvoi);

Procedure lanceRegressi;
var hSemaphore : integer;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication), nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
         eAddCol : if not ClientDDE.ExecuteMacro('CLIP|ADDCOL', false) then
            ShowMessage('Transfert non excut');
         eFocus : if not ClientDDE.ExecuteMacro('FOCUS', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
    LanceRegressi;
    ClientDDE.SetLink('Regressi','ServeurDDE');
    ClientItem.DDEItem := 'ServeurItem';
    if ClientDDE.OpenLink
        then lance
        else begin
            sleep(2000);
                    // OpenLik=false efface
            ClientDDE.SetLink('Regressi','ServeurDDE');
            ClientItem.DDEItem := 'ServeurItem';
            if ClientDDE.OpenLink
               then lance
               else if premiereFois
                    then ShowMessage('Impossible de lancer Regressi');
            premiereFois :=false
        end;
end;

procedure TFormDDE.AjouteConst(var donnees : tstringList);
var valeurConst : extended;
begin with ConstanteDlg do begin
     if (NomConstEdit.text='') then exit;
     ValeurConst := StrToFloatWin(ValeurConstEdit.text);
     if isnan(valeurConst) then exit;
     Donnees.Add('');
     Donnees.Add(NomConstEdit.text+crTab);
     Donnees.Add(UniteConstEdit.text+crTab);
     Donnees.Add(FloatToStrWin(valeurConst)+crTab);
end end;

procedure TFormDDE.EnvoieDonneesOsc(DDE,UnePeriode : boolean);

Procedure ChercheUnTour(const X,Y : VecteurOsc;N : indiceVecteurOsc;
                      var iDebut,iFin : integer);
const EcartMin = 0.05;
      EcartMax = 0.5;{ min, max pour hystrsis }
var i,i0 : indiceVecteurOsc;
    CoeffY,CoeffX : double;
    minLoc,ecartLoc : double;

Function GetCoeff(const V : VecteurOsc) : double;
var i : indiceVecteurOsc;
    mini,maxi : double;
begin
     Mini := V[1];
     Maxi := V[1];
     for i := 2 to N do
         if V[i]>Maxi
            then Maxi := V[i]
            else if V[i]<Mini
               then Mini := V[i];
     result := 1/(Maxi-Mini);
end;

Function ecart : double;
begin
      ecart := abs(CoeffY*(Y[i]-Y[i0]))+abs(CoeffX*(X[i]-X[i0]))
end;

Procedure ChercheIdebut;
var xmin,xmax,ymin,ymax : integer;
    ixmin,ixmax,iymin,iymax : integer;
    i : integer;
begin
     ixmin := 1;
     ixmax := 1;
     iymin := 1;
     iymax := 1;
     i0 := 1;
     xmin := X[1];
     xmax := X[1];
     ymin := Y[1];
     ymax := Y[1];
     for i := 2 to N div 2 do begin
         if X[i]>xmax then begin
            xmax := x[i];
            ixmax := i;
         end;
         if X[i]<xmin then begin
            xmin := x[i];
            ixmin := i;
         end;
         if Y[i]>ymax then begin
            ymax := y[i];
            iymax := i;
         end;
         if Y[i]<ymin then begin
            ymin := y[i];
            iymin := i;
         end;
     end;
     if (ixmin<=ixmax) and
        (ixmin<=iymin) and
        (ixmin<=iymax)
          then i0 := ixmin
          else if (ixmax<=iymax) and
                  (ixmax<=iymin)
               then i0 := ixmax
               else if (iymin<=iymax)
                    then i0 := iymin
                    else i0 := iymax
end; { ChercheIdebut }

begin
     iFin := N;
     iDebut := 1;
     if N<16 then exit;
     CoeffY := GetCoeff(y);
     CoeffX := GetCoeff(x);
     ChercheIdebut;
     i := i0;
     repeat inc(i)
     until (ecart>ecartMax) or (i=N);
     { on est loin du dpart }
     if i=N then exit;
     repeat inc(i)
     until (ecart<ecartMin) or (i=N);
     { on est prs de la boucle }
     if i=N then exit;
     iFin := i;
     MinLoc := ecartMin;
     repeat
         inc(i);
         ecartLoc := ecart; { pour viter de calculer 3 fois }
         if ecartLoc<MinLoc then begin
             minLoc := ecartLoc;
             iFin := i;
         end; { on se rapproche }
     until (ecartLoc>ecartMin) or (i=N);
       { on sloigne de nouveau ou on a fini }
     if iFin<N then inc(iFin); { on ferme le tour }
     iDebut := i0;
end; { chercheUnTour }

Procedure VerifFech(v : indiceVoieOsc);
var j0,LongTrame : integer;

Function ZeroExiste : boolean;
const jmax = 21;
var j1,l,t : integer;
    premiereTrame,trame : set of byte;
begin with oscilloForm.grapheOsc.voie[v] do begin
          j0 := 0;
          while (valeur[j0]<>0) and (j0<jmax) do inc(j0);
          if valeur[j0]=0 then begin { Acquisition avec des trous  zro }
             j0 := 0;
             while (valeur[j0]=0) and (j0<jmax) do inc(j0);
             { j0 = 1re donne correcte }
             result := valeur[j0]<>0;
             if not result then exit;
             L := 2;
             LongTrame := 0;
             repeat
                 premiereTrame := [];
                 for j1 := 0 to pred(L) do
                     if valeur[j1]=0 then include(premiereTrame,j1);
                 for t := 1 to 8 do begin
                     trame := [];
                     for j1 := 0 to pred(L) do
                         if valeur[t*L+j1]=0 then include(Trame,j1);
                     if trame<>premiereTrame then break;
                 end;
                 if trame=premiereTrame then LongTrame := L;
                 inc(L);
             until (L=jmax) or (LongTrame>0);
             result := LongTrame>0;
          end
          else result := false
end end;

var j,j1 : integer;
begin if ZeroExiste then with oscilloForm.grapheOsc do begin
          for j := 0 to NbreData div LongTrame do begin
              j1 := j0+LongTrame*j;
              voie[voieA].valeur[j] := voie[voieA].valeur[j1];
              voie[voieB].valeur[j] := voie[voieB].valeur[j1];
          end;
          NbreData := NbreData div LongTrame;
          voie[voieT].increment := voie[voieT].increment*LongTrame;
    end;
end;

var i : indiceVecteurOsc;
    v,vbis : indiceVoieOsc;
    ligne : string;
    donnees : tStringList;
begin with oscilloForm,grapheOsc do begin
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     indexData := 0;
     if ConstanteDlg.NewPageCB.itemIndex=0
        then Donnees.Add('Acquisition par oscillo '+identiteScope)
        else Donnees.Add('');
     Donnees.Add(ConstanteDlg.EditComm.text);
     with Voie[voieT] do
          Ligne := nom+crTab;
     for v := voieA to voieMax do with Voie[v] do
         if active then begin
            nom := nomEdit.text;
            if nom='' then nom := 'V'+intToStr(v);
            for vbis := voieA to pred(v) do
                if nom=voie[vbis].Nom then nom := nom+intToStr(v);
            ligne := ligne+nom+crTab;
         end;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieT to voieMax do with Voie[v] do
         if active then ligne := ligne+unite+crTab;
     Donnees.Add(ligne);
     with Voie[voieT] do
          Ligne := signif+crTab;
     for v := voieA to voieMax do with Voie[v] do begin
         if active then begin
            signif := signifEdit.text;
            ligne := ligne+signif+crTab;
         end;
     end;    
     Donnees.Add(ligne);
     if voie[voieA].active
        then verifFech(voieA)
        else verifFech(voieB);
     if unePeriode and (voie[voieA].active) and (voie[voieB].active)
        then chercheUnTour(voie[voieA].valeur,voie[voieB].valeur,
           NbreData,DebutOsc,FinOsc)
        else begin
            DebutOsc := 0;
            FinOsc := pred(NbreData);
        end;
     for i := debutOsc to finOsc do begin
         ligne := '';
         for v := voieT to voieMax do with voie[v] do if active then
             ligne := ligne+chaineVolt(i)+crTab;
         Donnees.Add(ligne);
     end;
     AjouteConst(donnees);
     ClipBoard.asText := Donnees.text;
     if DDE then if ConstanteDlg.NewPageCB.itemIndex=0
           then Execute(eLOAD)
           else Execute(eADD);
     Donnees.free;
     ConstanteDlg.NewPageCB.itemIndex := 1
end end;

Procedure TFormDDE.EnvoieDonneesMult(DDE : boolean);
var i : indiceVecteurOsc;
    v : indiceVoieMult;
    ligne : string;
    donnees : tstringList;
begin with MultimetreForm,graphe do begin
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     Donnees.Add('Acquisition par oscillo '+OscilloForm.identiteScope);
     Ligne := '';
     for v := voieX to NbreVoiesMax do with voie[v] do
         if active then ligne := ligne + nom + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieX to NbreVoiesMax do with voie[v] do
         if active then ligne := ligne + unite+crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieX to NbreVoiesMax do with voie[v] do
         if active then ligne := ligne + signif+crTab;
     Donnees.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         ligne := '';
         for v := voieX to NbreVoiesMax do with voie[v] do if active then
             ligne := ligne + FloatToStrWin(valeur[i])+crTab;
         Donnees.Add(ligne);
     end;
     clipBoard.asText := Donnees.text;
     if DDE then if ConstanteDlg.NewPageCB.itemIndex=0
           then Execute(eLOAD)
           else Execute(eADD);
     Donnees.free;
end end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TregIniFile;
begin
    premiereFois := true;
    Ini := TregIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
    Ini.Free;
    if ClientDDE.ServiceApplication='' then begin
       Ini := TRegIniFile.create('Software');
       ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','');
       Ini.Free;
    end;
end;

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
var Option : string;
    Fonction : string;
    ArgStart,ArgEnd : byte;
begin
     if (Msg.Count >= 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then begin
             Option := '';
             ArgStart := length(msg[0]);
          end
          else begin
             Option := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
             dec(ArgStart);
          end;
       Fonction := Copy(Msg[0], 1, ArgStart);
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) or
          (CompareText('CONFIG|SAVE',Fonction) = 0) then begin
             ConstanteDlg.NewPageCB.itemIndex := 1;
             OscilloForm.setFocus;
             exit;
       end;
       if (CompareText('FOCUS',Fonction) = 0)  then begin
             OscilloForm.setFocus;
             exit;
       end;
       if (CompareText('GETDATA',Fonction) = 0) then begin
             ConstanteDlg.NewPageCB.itemIndex := 1;
             postMessage(OscilloForm.Handle,WM_ACQ_REG,0,0);
             exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
       end;
     end;
end;

procedure TFormDDE.AjouteDonneesOscillo;
var i : indiceVecteurMult;
    v : indiceVoieOsc;
    ligne : string;
    donnees : tstringList;
begin with oscilloForm,grapheOsc do begin
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add('');
     Ligne := '';
     for v := voieA to voieMax do with voie[v] do if active then
         ligne := ligne + nom[indexData] + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieA to voieMax do with voie[v] do if active then
         ligne := ligne + unite + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieA to voieMax do with voie[v] do if active then
         ligne := ligne + signif[indexData] + crTab;
     Donnees.Add(ligne);
     for i := DebutOsc to FinOsc do begin
         ligne := '';
         for v := voieA to voieMax do with voie[v] do if active then
             ligne := ligne + chaineVolt(i) + crTab;
         Donnees.Add(ligne);
     end;
     ClipBoard.asText := Donnees.text;
     Execute(eADDCOL);
     donnees.free;
     Screen.Cursor := crDefault;
end end;

end.
