unit Mxmain;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, adexcept, registry, oomisc, printers, inifiles, math,
  jmmUtil, mxDDE, mxGraphe, ComCtrls, ToolWin, ImgList, XPMan;

const RegMetrix = 'Software\Metrix';
      FontSizeImpr = 10;
      Terminateur = crCR;

type
   TetatAttente = (atDiese,atNbreChiffre,atNbreData,atData,atStatus);
   TformatFichier = (fRW3,fTableur);
   TModeOscillo = (ModeSingle,refreshOn,refreshOff,ModeRoll);
   Tbalayage = (bCH1,bCH2,bXY,bCH12);
   ThandShake = (hXON,hDTR,hNone);
   pseudoWord = record case byte of
             0 : (octets : array[0..3] of ansiChar);
             1 : (mot : word);
             2 : (entier : smallInt);
             3 : (motLong : longWord);
             4 : (octet : byte);
             5 : (entierLong : LongInt);
   end;

  TOscilloForm = class(TForm)
    SaveDialog: TSaveDialog;
    PanelAide: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    VoieSerie: TApdComPort;
    gauge1: TProgressBar;
    Gauge2: TProgressBar;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    FileSaveBtn: TToolButton;
    ClipSaveBtn: TToolButton;
    RegSaveBtn: TToolButton;
    EnregistreBtn: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ResetBtn: TToolButton;
    StopBtn: TToolButton;
    ExitBtn: TToolButton;
    MultimetreBtn: TToolButton;
    XYBtn: TCheckBox;
    ToolButton1: TToolButton;
    ToolButton3: TToolButton;
    XPManifest1: TXPManifest;
    Oscillo: TPaintBox;
    GroupBox3: TGroupBox;
    gauge3: TProgressBar;
    GroupBox4: TGroupBox;
    gauge4: TProgressBar;
    ProblemePanel: TPanel;
    AnalogLabel: TLabel;
    TrcBtn: TToolButton;
    ToolButton4: TToolButton;
    Panel1: TPanel;
    Nom1Edit: TLabeledEdit;
    Panel2: TPanel;
    Nom2Edit: TLabeledEdit;
    Panel3: TPanel;
    Nom4Edit: TLabeledEdit;
    Panel4: TPanel;
    Nom3Edit: TLabeledEdit;
    SignifEdit4: TLabeledEdit;
    SignifEdit3: TLabeledEdit;
    SignifEdit1: TLabeledEdit;
    SignifEdit2: TLabeledEdit;
    procedure ShowHint(Sender: TObject);
    procedure ExitItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure AboutItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ResetOscilloClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SaveData(const NomFichier : string);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure RegressiNewFileItemClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure MultimetreBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure TrcBtnClick(Sender: TObject);
  private
    ModeOscillo : TmodeOscillo;
    OscilloNonBranche : boolean;
    EnTeteMX : ansiString;
    ChaineNbreData : string;
    NbreCourant,NbreChiffre : integer;
    VoieCourante : indiceVoieOsc;
    AcqFaite,DonneesSauvees : boolean;
    Attente : TetatAttente;
    Balayage : Tbalayage;
    AppelRegressi : boolean;
    AjouterPermis : boolean;
    ArretForce : boolean;
    CodeVoie : array[indiceVoieOsc] of char;
    DureeLectureVoie : integer;
    timeOut : integer;
    nbreOctet,indiceOctet : integer;
    valeurEnCours : pseudoWord;
    gaugeCourante : TProgressBar;
{$IFDEF debug}
    fichierTest : textFile;
{$ENDIF}
    Procedure SetBoutonAcq;
    Procedure ResetOscillo;
    Function ExtraitString(const titre : ansiString;num : byte) : ansiString;
    Function ExtraitInt(const titre : ansiString;num : byte) : integer;
    Function ExtraitFloat(const titre : ansiString;num : byte) : double;
    Procedure litConfigRS232;
    Procedure ecritConfigRS232;
    Procedure AttenteSingle;
    Function WaitOPC : boolean;
    Function WaitCrLF(var chaineLue : ansiString) : boolean;
  public
     IdentiteScope : ansiString;
     grapheOsc : TgrapheOsc;
     NomOscillo : ansiString;
     Measure : boolean;
     IndexData : integer;
     isMTX,isOX6 : boolean;
     withCLS : boolean;
     HandShake : ThandShake;
     Function GetString(const commande : ansiString) : ansiString;
     Function GetFloat(const commande : ansiString;unite : string) : double;
     Function GetBool(const commande : ansiString) : boolean;
     Function GetInt(const commande : ansiString;defaut : integer) : integer;
     procedure EnvoieCommande(const commande : ansiString);
     Function ExtraitStringMTX(const titre : ansiString;num : byte) : ansiString;
     Function ExtraitFloatMTX(const titre : ansiString;num : byte) : double;
     procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
  protected
     procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
     procedure WMAcqReg(var Msg : TMessage); message WM_Acq_Reg;
  end;

var
  OscilloForm: TOscilloForm;

implementation

uses MxAbout, mxCfg, Mxmult, Mxvoies, MXconst;

{$R *.DFM}

const
    ProtocolHard : THWFlowOptionSet = [hwfUseDTR,hwfUseRTS,hwfRequireDSR,hwfRequireCTS];
    timeOutUneSec = 18;
    timeOutIDN = 3*timeOutUneSec;
    timeOutOPC = 8*timeOutUneSec;

procedure TOscilloForm.AppMessage(var Msg: TMsg; var Handled: Boolean);

function CouperCopier : boolean;
begin
   result := ((msg.Wparam=22) or (msg.Wparam=3)) and
             (Screen.ActiveControl is TCustomEdit);
 { 3  ctrl C copy }
 { 22 ctrl V paste }
 { 1  ctrl A select All ; alpha ? }
 { 24 ctrl X cut ; xsi ? }
end;

const
        GrecMaj : array[0..25] of char =
  (AlphaMaj,BetaMaj,ChiMaj,deltaMaj,EpsilonMaj,phiMaj,gammaMaj,etaMaj,
   iotaMaj,psiMaj,kappaMaj,lambdaMaj,MuMaj,NuMaj,omicronMaj,piMaj,thetaMaj,
   rhoMaj,sigmaMaj,tauMaj,upsilonMaj,'V',omegaMaj,xiMaj,'Y',zetaMaj);

        GrecMin : array[0..25] of char =
  (alpha,beta,chi,delta,epsilon,phi,gamma,eta,iota,psi,kappa,lambdaMin,
   mu,nu,omicron,piMin,theta,rho,sigmaMin,tau,upsilon,'v',omega,xi,'y',zeta);

begin with Msg do
     case Message of
          wm_char : if (Wparam>0) and (Wparam<=24) then
             if (GetKeyState(vk_control)<0) then
                 if (GetKeyState(vk_shift)<0)
                    then Wparam := ord(GrecMaj[Wparam])
                    else if not CouperCopier
                         then Wparam := ord(GrecMin[Wparam]);
    end;
end;

procedure TOscilloForm.ShowHint(Sender: TObject);
begin
    PanelAide.Caption := Application.Hint
end;

procedure TOscilloForm.ExitItemClick(Sender: TObject);
begin
  if AcqFaite and not DonneesSauvees and
     (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
     then SaveItemClick(sender);
  Close;
end;

procedure TOscilloForm.SaveItemClick(Sender: TObject);
begin
     if SaveDialog.Execute then SaveData(saveDialog.FileName)
end;

procedure TOscilloForm.AboutItemClick(Sender: TObject);
begin
    AboutBox.ShowModal
end;

procedure TOscilloForm.FormCreate(Sender: TObject);
begin
  Attente := atStatus;
  OscilloNonBranche := true;
  AppelRegressi := false;
  timeOut := timeOutUneSec;
  Application.OnHint := ShowHint;
  Application.OnMessage := AppMessage;
  AcqFaite := false;
  grapheOsc := TgrapheOsc.create;
  grapheOsc.canvas := oscillo.canvas;
  grapheOsc.voie[voieT].gauge := gauge1;
  grapheOsc.voie[voieA].gauge := gauge1;
  grapheOsc.voie[voieB].gauge := gauge2;
  grapheOsc.voie[voieT].NomEdit := Nom1Edit;
  grapheOsc.voie[voieA].NomEdit := Nom1Edit;
  grapheOsc.voie[voieB].NomEdit := Nom2Edit;
  grapheOsc.voie[voieT].SignifEdit := SignifEdit1;
  grapheOsc.voie[voieA].SignifEdit := SignifEdit1;
  grapheOsc.voie[voieB].SignifEdit := SignifEdit2;
//  grapheOsc.voie[voieC].gauge := gauge3;
//  grapheOsc.voie[voieD].gauge := gauge4;
//  grapheOsc.voie[voieC].NomEdit := Nom3Edit;
//  grapheOsc.voie[voieD].NomEdit := Nom4Edit;
//  grapheOsc.voie[voieC].SignifEdit := SignifEdit3;
//  grapheOsc.voie[voieD].SignifEdit := SignifEdit4;
  Measure := false;
  indexData := 0;
  litConfigRS232;
end;

procedure TOscilloForm.EnregistreBtnClick(Sender: TObject);
var ModeAnalog : boolean;

Procedure VerifModeOscillo;
var reponse : ansiString;
begin
     modeAnalog := pos('AN',getString('MODE?'))<>0;
     AnalogLabel.caption := 'Capture numrique en mode analogique ! => problmes possibles.';
     AnalogLabel.visible := modeAnalog;
     if modeAnalog
        then begin
            envoieCommande('MODE NUM');
            attenteSingle;
            sleep(500);
        end
        else begin
            reponse := getString('ACQ:MODE?');
            modeOscillo := ModeSingle;
            if pos('REFR',reponse)<>0 then
               if pos('ON',getString('INIT:CONT?'))<>0
                  then begin
                     modeOscillo := refreshON;
                     attenteSingle;
                  end
                  else modeOscillo := refreshOFF;
            if pos('ROLL',reponse)<>0 then begin
               modeOscillo := modeRoll;
               envoieCommande('ABOR');
               showMessage('Arrt de l''acquisition avec dfilement (ROLL)');
             end;
         end;
     reponse := getString('DISP:MODE?');
     Balayage := bCH1;
     XYBtn.visible := reponse='XY';
     if not XYBtn.visible then XYBtn.checked := false;
     codeVoie[voieA] := '1';
     codeVoie[voieB] := '1';
     if reponse='CH1' then Balayage := bCH1;
     if reponse='CH2' then Balayage := bCH2;
     if reponse='XY' then Balayage := bXY;
     if reponse='DUAL' then Balayage := bCH12;
     if reponse='ALT' then Balayage := bCH12;
     if reponse='CHOP' then Balayage := bCH12;
     if reponse='ADD' then Balayage := bCH1;
     if reponse='MULT' then Balayage := bCH1;
     grapheOsc.voie[voieA].active := balayage in [bCH1,bCH12,bXY];
     grapheOsc.voie[voieB].active := balayage in [bCH2,bCH12,bXY];
     if balayage in [bCH12,bXY] then codeVoie[voieB] := '2';
end;

Procedure VerifModeMTX;
var reponse : string;
    v : indiceVoieOsc;
begin
     modeAnalog := false;
     reponse := GetString('TRAC:CAT?');
     for v := voieA to voieMax do
         grapheOsc.voie[v].active := pos('INT'+intToStr(v),reponse)>0;
     if getBool('TRIG:RUN:STAT?')
        then begin
             modeOscillo := refreshON;
             envoieCommande('TRIG:RUN:STAT OFF'); // arrt
             envoieCommande('INIT:NAME'); // acquisition en monocoup
             Attente := atStatus;
             WaitOPC; // attente fin acquisition
        end
        else modeOscillo := ModeSingle;
     reponse := getString('DISP:TRAC:FORM?');
     if reponse='XY'
         then begin
             Balayage := bXY;
             XYBtn.visible := true
         end
         else begin
             Balayage := bCH12;
             XYBtn.visible := false;
             XYBtn.checked := false;
         end;
end;

procedure LitVoie(v : indiceVoieOsc);
var old : double;
    j : integer;
    InstantDebut : TdateTime;
    HorsDelai : boolean;
    taille : longInt;
    nomFichier : string;
begin
    Attente := atDiese;
    EnTeteMX := '';
    voieCourante := v;
    NbreCourant := 0;
    gaugeCourante := grapheOSc.voie[v].Gauge;
    grapheOsc.voie[v].Gauge.position := 0;
    VoieSerie.OnTriggerAvail := VoieSerieTriggerAvail;
    VoieSerie.swFlowOptions := swfNone; // donnes en binaire
    AcqFaite := false;
    ArretForce := false;
    stopBtn.visible := true;
{$IFDEF debug}
    nomFichier := extractFilePath(Application.exeName)+'Metrix-CH'+intToStr(v)+'.jmm';
    AssignFile(fichierTest,nomFichier);
    Rewrite(fichierTest);
{$ENDIF}
    if isMTX
       then EnvoieCommande('TRAC? INT'+intToStr(v))
       else EnvoieCommande('TRACE? S'+codeVoie[v]);
    PanelAide.caption := 'Lecture de CH'+intToStr(v)+ ' en cours, Stop pour arrter';
    InstantDebut := time;
    if isMTX then grapheOsc.voie[v].gauge.Max := grapheOsc.NbreData;
    repeat
        grapheOsc.voie[v].Gauge.position := NbreCourant;
        Application.processMessages;
        HorsDelai := DureeEcoulee(InstantDebut)>DureeLectureVoie;
    until AcqFaite or ArretForce or HorsDelai;
    if handShake=hXon then VoieSerie.swFlowOptions := swfBoth;
    VoieSerie.OnTriggerAvail := nil;
    stopBtn.visible := false;
    if AcqFaite
       then begin
          PanelAide.caption := 'Lecture du calibre de CH'+intToStr(v);
          with grapheOsc.voie[voieT] do begin
               old := increment;
               increment := extraitFloat('SCAL',1); // e [20]
{$IFDEF debug}
               writeln(fichierTest,'IncX=',increment);
               if isMTX
                  then writeln(fichierTest,'MTX=true')
                  else writeln(fichierTest,'MTX=false');
               if isOX6
                  then writeln(fichierTest,'OX6=true')
                  else writeln(fichierTest,'OX6=false');
{$ENDIF}
               AjouterPermis := AjouterPermis and (old=increment);
               precision := round(abs(log10(increment)))+2;
               if precision<6 then precision := 6; { s }
               origine := 0;
               if isMTX
                  then calibre := grapheOsc.NbreData*increment
                  else calibre := 1000*increment;
          end;
          with grapheOsc.voie[v] do begin
               offsetAna := GetFloat('VOLT'+intToStr(v)+':RANG:OFFS?','V');
               if isnan(offsetAna) then offsetAna := 0;

{$IFDEF debug}      writeln(fichierTest,'PosY=',offsetAna); {$ENDIF}

               for j := grapheOsc.NbreData to maxVecteurOsc do valeur[j] := 0;
               increment := extraitFloat('SCAL',2);

{$IFDEF debug}      writeln(fichierTest,'IncY=',increment); {$ENDIF}

               precision := round(abs(log10(increment)))+1;
               if precision<3 then precision := 3; { mV }
               origine := extraitInt('OFFS',1); // MTX : OFFSet[20]393216 fixe = $060000

{$IFDEF debug}      writeln(fichierTest,'OffsetY=',origine); {$ENDIF}

               if isMTX
                  then begin
                     taille := extraitInt('SIZE',2); // SIZE[20]262144 fixe = $040000
                     if origine=0 then origine := $060000; // Offset non renseign ?
                     origine := origine+(taille div 2); // soit $080000
                // offset de Metrix serait en fait le bas de la courbe pas le zro
                // le zro serait toujours au milieu ?

{$IFDEF debug}        writeln(fichierTest,'SIZE=',taille); {$ENDIF}

                     calibre := taille*increment;
                  end
                  else calibre := 256*increment;
          end;
      end
      else begin
          if arretForce then showMessage('Acquisition arrte par l''utilisateur');
          if horsDelai then showMessage('Pas de rponse au bout de '+
                           intTostr(dureeLectureVoie)+' secondes');
          grapheOsc.NbreData := 0;
      end;
{$IFDEF debug} CloseFile(fichierTest); {$ENDIF}
end;

var vernier : boolean;
    v : indiceVoieOsc;
begin
     DureeLectureVoie := 5; // 1000 points
     if isMTX then if isOX6
     then begin
        envoieCommande('TRAC:LIM 0,2499,1'); // soit 2500 points
        grapheOsc.NbreData := 2499;
        DureeLectureVoie := 20; // 10 ko  9600 bauds major
     end
     else begin
        envoieCommande('TRAC:LIM 0,49999,10'); // soit 5000 points
        grapheOsc.NbreData := 4999;
        DureeLectureVoie := 36; // 20 ko  9600 bauds major
     end;
     AjouterPermis := AjouterPermis and AcqFaite;
     if OscilloNonBranche then begin
        ResetOscillo;
        if OscilloNonBranche then ResetOscilloClick(sender);
        if OscilloNonBranche then exit;
     end;
     EnregistreBtn.enabled := false;
     DonneesSauvees := false;
     AcqFaite := false;
     for v := voieA to voieMax do begin
         grapheOsc.voie[v].Gauge.position := 0;
         grapheOsc.voie[v].Gauge.upDate;
     end;
     PanelAide.caption := 'Lecture de l''tat de l''oscilloscope';
     PanelAide.Update;
     if isMTX
        then vernier := false
        else begin
            vernier := pos('ON',getString('INP1:VERN?'))<>0;
            vernier := vernier or (pos('ON',getString('INP2:VERN?'))<>0);
        end;
     if vernier then begin
          showMessage('Non calibrage, teindre voyant UNCAL');
          setBoutonAcq;
          exit;
     end;
     if not isMTX then envoieCommande('SYST:KLOCK ON');
     if isMTX
        then envoieCommande('FORM INT')
        else envoieCommande('FORM:DATA INT');
     envoieCommande('FORM:DINT OFF');
     if isMTX then verifmodeMTX else verifModeOscillo;
     for v := voieA to voieMax do
         if grapheOsc.voie[v].active then LitVoie(v);
     setBoutonAcq;
     if modeAnalog
        then envoieCommande('MODE AN')
        else case ModeOscillo of
             refreshON : if isMTX
                   then begin
                      envoieCommande('INIT:CONT:NAME ON'); // mode rptitif
                      envoieCommande('TRIG:RUN:STAT ON'); // marche
                   end   
                   else envoieCommande('INIT:CONT ON'); // retour  Refresh 
             refreshOFF : ;
             modeRoll : envoieCommande('INIT'); { ractiver }
             modeSingle : ;
       end;
     if not isMTX then envoieCommande('SYST:KLOCK OFF'); // dbloque touches oscillo
     AjouterPermis := AjouterPermis and (indexData<MaxCol);
     if AppelRegressi then begin
        FormDDE.EnvoieDonneesOsc(true,XYbtn.checked);
        AppelRegressi := false;
        indexData := 0;
        DonneesSauvees := true;
        AjouterPermis := true;
     end
     else oscillo.refresh
end;

procedure TOscilloForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
     if VoieSerie.Tracing=tlOn then begin
        VoieSerie.Tracing := tlDump;
        VoieSerie.Logging := tlDump;
     end;   
     EcritConfigRS232;
     voieSerie.open := false;
     Action := caFree;
{$IFDEF Debug}
     showMessage('Metrix.jmm .trc et .log dans '+
         extractFilePath(application.exeName)+'  envoyer')
{$ENDIF}
end;

procedure TOscilloForm.RegSaveBtnClick(Sender: TObject);
begin
      if constanteDlg.showModal=mrOk then begin
         FormDDE.EnvoieDonneesOsc(true,XYbtn.checked);
         DonneesSauvees := true;
      end;
end;

procedure TOscilloForm.SetBoutonAcq;
begin
     EnregistreBtn.visible := not OscilloNonBranche;
     FileSaveBtn.Visible := AcqFaite;
     RegSaveBtn.Visible := FileSaveBtn.Visible;
     EnregistreBtn.enabled := true;
     MultimetreBtn.visible := VoiesDlg.multimetreOK;
//   groupbox4.Visible := isMTX;
//   groupbox3.Visible := isMTX;
    
end;

procedure TOscilloForm.ResetOscillo;
var posOX : integer;
begin
     try // voie Srie
     AnalogLabel.Visible := false;
     case Handshake of
           hXON : begin
              VoieSerie.SWFlowOptions := swfBoth;
              VoieSerie.HWFlowOptions := [];
           end;
           hDTR : begin
              VoieSerie.SWFlowOptions := swfNone;
              VoieSerie.HWFlowOptions := ProtocolHard;
           end;
           hNone : begin
              VoieSerie.SWFlowOptions := swfNone;
              VoieSerie.HWFlowOptions := [];
           end;
     end;
     OscilloNonBranche := true;
     voieSerie.Open := true;
{$IFDEF debug}
     voieSerie.Tracing := tlOn;
     voieSerie.Logging := tlOn;
{$ELSE}
     if TrcBtn.down
        then begin
           VoieSerie.Tracing := tlOn;
           VoieSerie.Logging := tlOn;
        end
        else begin
           VoieSerie.Tracing := tlOff;
           VoieSerie.Logging := tlOff;
        end;
{$ENDIF}
     if withCLS then begin
        voieSerie.Output := '*CLS'+terminateur;
        sleep(500);
     end;
     timeOut := timeOutIDN;
     IdentiteScope := GetString('*IDN?'); // Identifie l'oscilloscope
     timeOut := timeOutUneSec;
     posOX := Pos('OX',IdentiteScope);
// OX 8020 8022 8040 8042 8050 8062 8100 7520
     OscilloNonBranche := PosOX=0;
     nomOscillo := IdentiteScope;
     isMTX := false;
     isOX6 := false;
     if OscilloNonBranche then begin
        posOX := Pos('MTX',IdentiteScope);
// MTX 3352 3257 renvoie MTX3252-C,[20]V2.02/BC0,[20]145387CEH[0A][0D]
        OscilloNonBranche := PosOX=0;
        if posOX>0 then nomOscillo := copy(IdentiteScope,posOX,7);
        isMTX := true;
     end
     else begin // OX6062 ?
          posOX := Pos('OX6',IdentiteScope);
          isOX6 := posOX>0;
          isMTX := isOX6;
     end;
//     grapheOsc.voie[voieC].active := isMTX and not OscilloNonBranche;
//     grapheOsc.voie[voieD].active := grapheOsc.voie[voieC].active;
     if OscilloNonBranche
         then begin
             VoieSerie.Open := false;
             AnalogLabel.Caption := 'Oscilloscope non dtect sur '+ComName(voieSerie.comNumber);
             AnalogLabel.visible := true;             
         end
         else Caption := NomOscillo+' vers Regressi';
     SetBoutonAcq;
     except
         on E : EAPDexception do begin
            VoieSerie.Open := false;
            OscilloNonBranche := true;
            AnalogLabel.Caption := 'Problme voie srie sur '+ComName(voieSerie.comNumber);
            AnalogLabel.Visible := true;
         end;
     end;
end;

procedure TOscilloForm.ResetOscilloClick(Sender: TObject);
begin
     ComCfgDlg.HandshakeRG.itemIndex := ord(handShake);
     comcfgDlg.traceCB.Checked := trcBtn.down;
     if ComCfgDlg.ShowModal=mrOK then begin
        trcBtn.Down := comcfgDlg.traceCB.Checked;
        ResetOscillo;
     end;
end;

procedure TOscilloForm.FormActivate(Sender: TObject);
begin
     ResetOscillo;
     if OscilloNonBranche then resetOscilloClick(sender);
end;

Function TOscilloForm.GetString(const Commande : ansiString) : ansiString;
var chaineLue : ansiString;
begin
    repeat
       VoieSerie.FlushInBuffer;
       sleep(50);
    until not voieSerie.CharReady;
    VoieSerie.OutPut := Commande+Terminateur;
    if WaitCrLf(chaineLue)
        then result := chaineLue 
        else result := '';
end;

Procedure TOscilloForm.AttenteSingle;
begin
    envoieCommande('ACQ:MODE SING');
    envoieCommande('INIT');
    Attente := atStatus;
    WaitOPC;
end;

Procedure TOscilloForm.EnvoieCommande(const Commande : ansiString);
var ET : eventTimer;
begin
    VoieSerie.OutPut := Commande+Terminateur;
    newTimer(ET,9);
    repeat
        Application.processMessages
    until (VoieSerie.OutBuffUsed=0) or timerExpired(ET);
end;

procedure TOscilloForm.SaveData(const NomFichier : string);
var fichier : textFile;
    formatFichier : TFormatFichier;
    NbreVoies : byte;

Procedure EcritPage;
var j : indiceVecteurOsc;
    v : indiceVoieOsc;
begin
case formatFichier of
    fRW3 : begin
       writeln(fichier,SymbReg,'1 PAGE COMMENT');
       writeln(fichier,'');
       writeln(fichier,SymbReg2,grapheOsc.NbreData-1,' VALEUR VAR');
       for j := 0 to (grapheOsc.NbreData-2) do begin
           for v := voieT to VoieMax do with grapheOsc.voie[v] do if active then
              write(fichier,chaineVolt(j),' ');
           writeln(fichier);
       end // j
    end;// RW3
    ftableur : begin
        for j := 0 to (grapheOsc.NbreData-2) do begin
            for v := voieT to voieMax do with grapheOsc.voie[v] do
               if active then write(fichier,chaineVolt(j),crTab);
            writeln(fichier);
        end; // j
    end; // tableur}
    end // case
end; {ecritPage}

Procedure ecritEnTete;
var j : indiceVoieOsc;
begin
case formatFichier of
   fRW3 : begin
   writeln(fichier,'EVARISTE REGRESSI WINDOWS 1.0');
   writeln(fichier,symbReg,NbreVoies,' NOM VAR');
   for j := voieT to voieMax do if grapheOsc.voie[j].active then
       writeln(fichier,grapheOsc.voie[j].nom);
   writeln(fichier,symbReg,NbreVoies,' UNITE VAR');
   for j := voieT to VoieMax do if grapheOsc.voie[j].active then
      writeln(fichier,grapheOsc.voie[j].unite);
   writeln(fichier,symbReg,NbreVoies,' SIGNIF VAR');
   for j := voieT to VoieMax do if grapheOsc.voie[j].active then
      writeln(fichier,grapheOsc.voie[j].signif);
   writeln(fichier,symbReg,'1 ACQUISITION');
   writeln(fichier,Application.ExeName)
   end;{RW3}
   fTableur : begin
   writeln(fichier,'Metrix '+nomOscillo);
   for j := voieT to VoieMax do if grapheOsc.voie[j].active then
      write(fichier,grapheOsc.voie[j].nom,crTab);
   writeln(fichier);
   for j := voieT to VoieMax do if grapheOsc.voie[j].active then
      write(fichier,grapheOsc.voie[j].unite,crTab);
   writeln(fichier);
   for j := voieT to VoieMax do if grapheOsc.voie[j].active then
      write(fichier,grapheOsc.voie[j].signif,crTab);
   writeln(fichier);
   end;{tableur}
end; {case} end; { ecritEnTete }

var v : indiceVoieOsc;
    extens : string;
begin
    Screen.cursor := crHourGlass;
    extens := AnsiUpperCase(ExtractFileExt(NomFichier));
    formatFichier := ftableur;
    if extens='.RW3' then formatFichier := fRw3;
    AssignFile(fichier,NomFichier);
    Rewrite(fichier);
    NbreVoies := 1;
    for v := voieA to voieMax do
        if grapheOsc.voie[v].active then inc(NbreVoies);
    ecritEnTete;
    ecritPage;
    CloseFile(fichier);
    DonneesSauvees := true;
    Screen.cursor := crDefault;
end;

Function ToscilloForm.ExtraitString(const titre : ansiString;num : byte) : ansiString;
var j,debut : integer;
    tampon : ansiString;     // titre XYZ : recherche XYZabc[20]
begin
     extraitString := '';
     tampon := enTeteMX;
     for j := 1 to num do begin
         debut := pos(titre,tampon);
         if debut>0
            then delete(tampon,1,debut+length(titre)-1)
            else exit; { donnes incorrectes }
     end;
     debut := pos(' ',tampon);
     if debut>0 then delete(tampon,1,debut) else exit;
     j := 0;
     while (length(tampon)>j) and (tampon[succ(j)] in chiffreEtc)
        do inc(j);
     extraitString := copy(tampon,1,j);
end;

Function ToscilloForm.ExtraitFloat(const titre : ansiString;num : byte) : double;
var tampon : ansiString;
begin
     tampon := extraitString(titre,num);
     try
     extraitFloat := StrToFloatWin(tampon);
     except
          extraitFloat := 0;
     end;
end;

Function ToscilloForm.ExtraitInt(const titre : ansiString;num : byte) : integer;
var tampon : ansiString;
begin
     tampon := extraitString(titre,num);
     try
     extraitInt := StrToInt(tampon);
     except
          extraitInt := 0
     end;
end;

procedure TOscilloForm.LitConfigRS232;

procedure litFichier;
var ini : TIniFile;
    nom : string;
    v : indiceVoieOsc;
begin
    try
    Nom := changeFileExt(application.exeName,'.ini');
    Ini := TIniFile.Create(nom);
    voieSerie.ComNumber := Ini.ReadInteger('COM','NUMBER',1);
    voieSerie.Baud := Ini.ReadInteger('COM','Baud',voieSerie.Baud);
    TrcBtn.down := Ini.ReadBool('COM','Tracing',false);
    withCLS := Ini.ReadBool('COM','CLS',withCLS);
    handshake := Thandshake(Ini.ReadInteger('COM','Handshake',ord(handshake)));
    for v := voieA to voieMax do begin
        grapheOsc.voie[v].NomEdit.text := ini.ReadString('Voie'+intToStr(v),'Nom','V'+intToStr(v));
        grapheOsc.voie[v].SignifEdit.text := ini.ReadString('Voie'+intToStr(v),'Signif','');        
    end;
    Ini.Free;
    except
    end;
end;

procedure litRegistre;
var RINI : TRegIniFile;
    v : indiceVoieOsc;
begin
    try
    RIni := TRegIniFile.Create(RegMetrix);
    voieSerie.ComNumber := RIni.ReadInteger('COM','NUMBER',1);
    voieSerie.Baud := RIni.ReadInteger('COM','Baud',9600);
    TrcBtn.down := RIni.ReadBool('COM','Tracing',false);
    withCLS := RIni.ReadBool('COM','CLS',false);
    handshake := Thandshake(RIni.ReadInteger('COM','Handshake',0));
    for v := voieA to voieMax do begin
        grapheOsc.voie[v].NomEdit.text := Rini.ReadString('Voie'+intToStr(v),'Nom','V'+intToStr(v));
        grapheOsc.voie[v].SignifEdit.text := Rini.ReadString('Voie'+intToStr(v),'Signif','');
    end;
    RIni.Free;
    except
    end;
end;

begin
    litRegistre;
    litFichier;
end;

procedure TOscilloForm.EcritConfigRS232;
var RINI : TregIniFile;
    ini : tIniFile;
    v : indiceVoieOsc;
begin
    try
    Ini := TIniFile.Create(changeFileExt(application.exeName,'.ini'));
    Ini.WriteInteger('COM','NUMBER',voieSerie.ComNumber);
    Ini.WriteBool('COM','Tracing',trcBtn.down);
    Ini.WriteInteger('COM','IDN',timeOutIDN);
    Ini.WriteBool('COM','CLS',withCLS);
    Ini.WriteInteger('COM','Baud',voieSerie.Baud);
    Ini.WriteInteger('COM','Handshake',ord(handshake));
    for v := voieA to voieMax do begin
        Ini.WriteString('Voie'+intToStr(v),'Nom',grapheOsc.voie[v].NomEdit.text);
        Ini.WriteString('Voie'+intToStr(v),'Signif',grapheOsc.voie[v].SignifEdit.text);
    end;
    Ini.Free;
    except
    end;
    try
    RIni := TRegIniFile.Create(RegMetrix);
    RIni.WriteInteger('COM','NUMBER',voieSerie.ComNumber);
    RIni.WriteBool('COM','Tracing',trcBtn.down);
    RIni.WriteInteger('COM','IDN',timeOutIDN);
    RIni.WriteBool('COM','CLS',withCLS);
    RIni.WriteInteger('COM','Baud',voieSerie.Baud);
    RIni.WriteInteger('COM','Handshake',ord(handshake));
    for v := voieA to voieMax do begin
        Rini.WriteString('Voie'+intToStr(v),'Nom',grapheOsc.voie[v].NomEdit.text);
        Rini.WriteString('Voie'+intToStr(v),'Signif',grapheOsc.voie[v].SignifEdit.text);
    end;
    RIni.Free;
    except
    end;
end;

procedure TOscilloForm.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var i,taille : integer;
    z : ansiChar;
{$IFDEF debug} j : integer; {$ENDIF}
begin
    z := #0;
    for i := 1 to count do begin
        if voieSerie.charReady
           then z := voieSerie.getChar
           else exit;
        case Attente of
             atStatus : ;
             atDiese : begin
                 if z='#'
                    then Attente := atNbreChiffre
                    else EnTeteMX := EnTeteMX+z;
             end;
             atNbreChiffre : begin
                NbreChiffre := ord(z)-ord('0');
                Attente := AtNbreData;
                ChaineNbreData := '';
{$IFDEF debug}
                for j := 1 to length(enTeteMX) do
                    if enTeteMX[j]>=' ' then begin
                       write(fichierTest,enTeteMX[j]);
                       if enTeteMX[j]=')' then writeln(fichierTest);
                    end;
                writeln(fichierTest);
                writeln(fichierTest,'#',z);
{$ENDIF}
             end;
             atNbreData : begin
                ChaineNbreData := ChaineNbreData+z;
                if length(ChaineNbreData)=NbreChiffre then begin
{$IFDEF debug}      writeln(fichierTest,'NbreData=',chaineNbreData); {$ENDIF}
                   Attente := atData;
                   grapheOsc.NbreData := StrToInt(ChaineNbreData); // 20000
                   DureeLectureVoie := ((grapheOsc.NbreData+150) div 200) + 1;
                       // 150 carac d'en tte
                   if isMTX
                      then if isOX6 then nbreOctet := 1
                      else begin
                         taille := ExtraitInt('SIZE',1); // 5000
                         nbreOctet := grapheOsc.NbreData div taille; // 4
{$IFDEF debug}            writeln(fichierTest,'taille=',taille); {$ENDIF}
                         grapheOsc.NbreData := grapheOsc.NbreData div NbreOctet;
                      end
                      else nbreOctet := 1;
{$IFDEF debug}      writeln(fichierTest,'Nbre octets=',nbreOctet); {$ENDIF}
                   if grapheOsc.NbreData>maxVecteurOsc then grapheOsc.NbreData := maxVecteurOsc;
                   gaugeCourante.Max := grapheOsc.NbreData;
                   gaugeCourante.position := 0;
                   NbreCourant := 0;
                   indiceOctet := NbreOctet;
                end;
             end;
             atData : if nbreOctet=1
                 then begin
                     grapheOsc.voie[voieCourante].valeur[NbreCourant] := ord(z);
                     inc(NbreCourant);
                     AcqFaite := NbreCourant>=grapheOsc.NbreData;
                     if AcqFaite then Attente := atStatus;
                 end
                 else begin
{ Le format des donnes est cod sur 32 bits (4octets)
  soit 20000 octets pour une courbe de 5000 points (5000 x 4 = 20000).
  Mais il y a une erreur page 23, on parle de donnes codes sur 8 bits
  alors que c'est sur 32 bits et page 21, on parle de 2500 pts alors que
  c'est 50000 sur les MTX3352-C }
                     dec(indiceOctet);
                     valeurEnCours.octets[indiceOctet] := z;
                     if indiceOctet=0 then begin
                        indiceOctet := NbreOctet;
                        grapheOsc.voie[voieCourante].valeur[NbreCourant] :=
                            valeurEnCours.EntierLong and $FFFFF;
                        // 20 bits donn par SIZE[20]262144=$4 00 00 ! ?
                        // dcalage de 393216 = $6 00 00 (offset)
                        // bit 31  1 => point invalide
                        // if (valeurEnCours.EntierLong and $80000000)=$80000000 then ;
                        inc(NbreCourant);
                        AcqFaite := NbreCourant>=grapheOsc.NbreData;
                        if AcqFaite then Attente := atStatus;
                     end;
                 end;
         end;{case}
    end;{i}
end;

procedure TOscilloForm.RegressiNewFileItemClick(Sender: TObject);
begin
      FormDDE.EnvoieDonneesOsc(true,XYbtn.checked);
      DonneesSauvees := true;
end;

procedure TOscilloForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
     with Msg.MinMaxInfo^ do begin
          ptMinTrackSize := point(450,230);
          ptMaxTrackSize := point(640,230);
     end;
end;

procedure TOscilloForm.WMAcqReg(var Msg : TMessage);
begin
    AppelRegressi := true;
    EnregistreBtnClick(nil);
end;

procedure TOscilloForm.StopBtnClick(Sender: TObject);
begin
     ArretForce := true
end;

Function ToscilloForm.WaitOPC : boolean;
var Timer : EventTimer;
    C : ansiChar;
begin
    VoieSerie.OutPut := '*OPC?'+Terminateur;
    newTimer(timer,timeOutOPC);
    arretForce := false;
    stopBtn.Visible := true;
    c := #0;
    repeat
        if voieSerie.charReady
           then C := voieSerie.GetChar
           else begin
              voieSerie.processCommunications;
              application.ProcessMessages;
           end;
    until (c='1') or timerExpired(timer) or arretForce;
    stopBtn.Visible := false;
    result := c='1';
end;

Function ToscilloForm.GetFloat(const Commande : ansiString;unite : string) : double;
const NomUnite : array[0..3] of string = ('Hz','V','','s');
var reponse : ansiString;
    u,posBlanc : integer;
begin
     try
     reponse := GetString(commande);
     if pos('--',reponse)>0 then begin
        result := nan;
        exit;
     end;
     while reponse[1]=' ' do reponse := copy(reponse,2,length(reponse));
     for u := 0 to 3 do begin
        posBlanc := pos(NomUnite[u],reponse);
        if posBlanc>0 then reponse := copy(reponse,1,posBlanc-1);
     end;
     result := StrToFloatWin(reponse);
     except
        result := nan
     end;
end;

Function ToscilloForm.ExtraitStringMTX(const titre : ansiString;num : byte) : ansiString;
var j,debut : byte;
    tampon : ansiString;
begin
     result := '';
     tampon := enTeteMX;
     for j := 1 to num do begin
         debut := pos(titre,tampon);
         if debut>0
            then delete(tampon,1,debut+length(titre)-1)
            else exit; { donnes incorrectes }
     end;
     debut := pos(' ',tampon);
     if debut>0 then delete(tampon,1,debut) else exit;
     j := 0;
     while (length(tampon)>j) and (tampon[succ(j)] in chiffreEtc)
        do inc(j);
     result := copy(tampon,1,j);
end;

Function ToscilloForm.ExtraitFloatMTX(const titre : ansiString;num : byte) : double;
var tampon : ansiString;
begin
     tampon := extraitStringMTX(titre,num);
     try
     result := StrToFloatWin(tampon); // NR3 1.02e5
     except
          result := 0;
     end;
end;

Function ToscilloForm.GetBool(const Commande : ansiString) : boolean;
var reponse : ansiString;
begin
     try
     reponse := GetString(commande);
     result := (pos('ON',reponse)>0) or (pos('1',reponse)>0);
     except
        result := false
     end;
end;

Function ToscilloForm.GetInt(const Commande : ansiString;defaut : integer) : integer;
begin
    try
    GetInt := StrToInt(GetString(commande));
    except
        GetInt := defaut
    end;
end;
 
procedure TOscilloForm.MultimetreBtnClick(Sender: TObject);
begin
    if multimetreForm=nil then MultimetreForm := TmultimetreForm.create(self);
    MultimetreForm.show;
end;

Function TOscilloForm.WaitCrLF(var chaineLue : ansiString) : boolean;
var Timer : EventTimer;
    C : ansiChar;
    compteur : integer;
begin
    newTimer(timer,timeOut); // 18 ticks = 1 seconde
    chaineLue := '';
    result := false;
    compteur := 0;
    repeat
        if voieSerie.charReady
           then begin
              C := voieSerie.GetChar;
              if C>=' '
                 then ChaineLue := chaineLue+C
                 else if (C=crLf) or(C=crCR) then
                      if isMTX then begin // Attendre CR et LF
                         inc(compteur);
                         result := compteur>=2;
                      end
                      else result := true;
           end
           else begin
               voieSerie.processCommunications;
               application.ProcessMessages;
           end;
    until result or timerExpired(timer);
end;

procedure TOscilloForm.ExitBtnClick(Sender: TObject);
begin
     Close
end;

procedure TOscilloForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesOsc(false,XYbtn.checked);
end;

procedure TOscilloForm.OscilloPaint(Sender: TObject);
var i : integer;
    coeffX,coeffY : double;
    x,y : integer;
    v : indiceVoieOsc;
begin with grapheOsc do begin
     canvas := oscillo.canvas;
     if NbreData<2 then exit;
     coeffX := oscillo.Width/NbreData;
     if isMTX
        then coeffY := oscillo.Height/1e6 // 20 bits
        else coeffY := oscillo.Height/256; // 8 bits
     for v := voieA to voieB do with voie[v] do
         if active then begin
            for i := 0 to pred(NbreData) do begin
               x := round(coeffX*i);
               y := oscillo.Height-round(valeur[i]*coeffY);
               oscillo.canvas.pixels[x,y] := couleur;
            end;
         end;
end end;

procedure TOscilloForm.TrcBtnClick(Sender: TObject);
begin
{$IFDEF debug}
{$ELSE}
     if TrcBtn.down then begin
         VoieSerie.Tracing := tlOn;
         VoieSerie.Logging := tlOn;
     end
     else if (VoieSerie.Tracing=tlOn) then begin
         VoieSerie.Tracing := tlDump;
         VoieSerie.Logging := tlDump;
     end;
{$ENDIF}
end;

end.



