unit Mxfreq;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, math,
  jmmUtil, MXgrapheMult, ComCtrls;

type
  TVoieXDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    GroupBox2: TGroupBox;
    GroupBox1: TGroupBox;
    NumVoieRG: TRadioGroup;
    GroupBox3: TGroupBox;
    logCB: TCheckBox;
    Bevel1: TBevel;
    MaxiSpin: TUpDown;
    MiniSpin: TUpDown;
    EditMaxi: TEdit;
    EditMini: TEdit;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure MaxiSpinClick(Sender: TObject; Button: TUDBtnType);
    procedure MiniSpinClick(Sender: TObject; Button: TUDBtnType);
  private
    function StrFrequence(freq : double) : string;
  public
     voieLue : Tvoie;
  end;

var
  VoieXDlg: TVoieXDlg;

implementation

{$R *.DFM}

function TVoieXDlg.StrFrequence(freq : double) : string;
begin
     if freq<1000
        then StrFrequence := IntToStr(round(freq))+' Hz'
        else if freq<1e6
            then StrFrequence := IntToStr(round(freq/1000))+' kHz'
            else StrFrequence := IntToStr(round(freq/1e6))+' MHz'
end;

procedure TVoieXDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
     MaxiSpin.position := round(3*log10(maxi));
     MiniSpin.position := round(3*log10(mini));
     MaxiSpin.min := MiniSpin.position+1;
     MiniSpin.max := MaxiSpin.position-1;
     EditMini.text := StrFrequence(mini);
     EditMaxi.text := StrFrequence(maxi);
     NumVoieRG.itemIndex := NumVoie-1;
     logCB.checked := AxeLog;
end end;

procedure TVoieXDlg.OKBtnClick(Sender: TObject);
begin with voieLue do begin
     NumVoie := NumVoieRG.itemIndex+1;
     AxeLog := logCB.checked;
end end;

procedure TVoieXDlg.MaxiSpinClick(Sender: TObject; Button: TUDBtnType);
begin with voieLue do begin
     MiniSpin.max := MaxiSpin.position-1;
     maxi := power(10,maxiSpin.position div 3);
     case maxiSpin.position mod 3 of
          0 : maxi := maxi;
          1 : maxi := 2*maxi;
          2 : maxi := 5*maxi;
     end;
     EditMaxi.text := StrFrequence(maxi);
end end;

procedure TVoieXDlg.MiniSpinClick(Sender: TObject; Button: TUDBtnType);
begin with voieLue do begin
     MaxiSpin.min := MiniSpin.position+1;
     mini := power(10,miniSpin.position div 3);
     case miniSpin.position mod 3 of
          0 : mini := mini;
          1 : mini := 2*mini;
          2 : mini := 5*mini;
     end;
     EditMini.text := StrFrequence(mini);
end end;

end.
