unit Mxmult;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, adexcept, inifiles, math,
  jmmUtil, MXGrapheMult, ComCtrls, ToolWin, ImgList;

type

  TMultimetreForm = class(TForm)
    OpenDialogConfig: TOpenDialog;
    SaveDialog: TSaveDialog;
    Oscillo: TPaintBox;
    PanelValeur: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBoxFreq: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    NewPageCB: TRadioGroup;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    FileSaveBtn: TToolButton;
    ClipSaveBtn: TToolButton;
    RegSaveBtn: TToolButton;
    ToolButton4: TToolButton;
    ResetDataBtn: TToolButton;
    UndoBtn: TToolButton;
    EnregistreBtn: TToolButton;
    ToolButton8: TToolButton;
    SauveConfigBtn: TToolButton;
    ToolButton10: TToolButton;
    ChargeConfigBtn: TToolButton;
    EXitBtn: TToolButton;
    PanelErreur: TPanel;
    MaJgb: TGroupBox;
    MesureCB: TCheckBox;
    EnregistreEdit: TEdit;
    Timer: TTimer;
    StatusBar: TStatusBar;
    StopBtn: TToolButton;
    LabelErreur: TLabel;
    LabelErreurlecture: TLabel;
    LabelMesure: TLabel;
    procedure ExitItemClick(Sender: TObject);
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegressiItemClick(Sender: TObject);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure ResetDataBtnClick(Sender: TObject);
    procedure ChargeconfigItemClick(Sender: TObject);
    procedure SauveConfigItemClick(Sender: TObject);
    procedure VoieClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure EnregistreEditKeyPress(Sender: TObject; var Key: Char);
    procedure Retour(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GroupBoxFreqClick(Sender: TObject);
    procedure MesureCBClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
  private
    FichierConfig   : string;
    arretLecture : boolean;
    isXP : boolean;
    dataSaved : boolean;
    Procedure SetBoutonAcq;
    Procedure SetVoies;
  public
    graphe : Tgraphe;
    Procedure LitConfig(const NomFichier : string);
    Procedure EcritConfig(const NomFichier : string);
  protected
  end;

var
  MultimetreForm: TMultimetreForm;

implementation

uses MxVoies, MxFreq, MxDDE, Mxmain, SysInfoCtrls, MXconst;

{$R *.DFM}

procedure TMultimetreForm.ExitItemClick(Sender: TObject);
begin
  if (graphe.NbrePoints>0) and  not (dataSaved) and
     (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
     then SaveItemClick(sender);
  OscilloForm.Close;
end;

procedure TMultimetreForm.SaveItemClick(Sender: TObject);
begin
     SaveDialog.filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
     SaveDialog.defaultExt := 'RW3';
     SaveDialog.title := 'Sauvegarde donnes';
     if SaveDialog.Execute then
         Graphe.SaveData(saveDialog.FileName);
     dataSaved := true;    
end;

procedure TMultimetreForm.FormCreate(Sender: TObject);
var i,v : integer;
begin
  Graphe := Tgraphe.Create;
  Graphe.Canvas := Oscillo.Canvas;
  Graphe.PanelErreurLect := PanelErreur;
  with PanelValeur do
     for i := 0 to pred(controlCount) do
         if (controls[i] is TgroupBox) then begin
            v := TGroupBox(controls[i]).tag;
            if (v>=voieX) and (v<=NbreVoiesMax) then begin
               graphe.voie[v].GBvoie := TgroupBox(controls[i]);
               graphe.voie[v].LabelVoie := Tlabel(TgroupBox(controls[i]).controls[0]);
               if not isXP then begin
                   graphe.voie[v].LabelVoie.Font.color := clWhite;
                   graphe.voie[v].GBVoie.Font.color := clWhite;
               end;
            end;
         end;
  litConfig(Application.exeName);
end;

procedure TMultimetreForm.EnregistreBtnClick(Sender: TObject);

procedure DemandeEtEnregistre;
var i : indiceVoieMult;
    comm : ansiString;
begin with graphe do begin
     LabelMesure.visible := true;
     cursor := crHourGlass;
     erreurLecture := false;
     EnregistreBtn.enabled := false;
     for i := voieX to NbreVoiesMax do with voie[i] do if active then begin
         oldValeur := valeurCourante;
         if OscilloForm.isMTX
            then begin
               comm := 'MEAS:'+CommandMTX+'? INT'+IntToStr(NumVoie);
               if commandMTX='PHAS'
                  then comm := comm+',INT'+IntToStr(NumVoieRef);
               ValeurCourante := OscilloForm.GetFloat(comm,unite);
            end
            else ValeurCourante := OscilloForm.GetFloat('MEAS:'+Command+'? (@'+IntToStr(NumVoie)+')','');
         erreurLecture := erreurLecture or isnan(ValeurCourante);
         LabelVoie.caption := nom+'='+strValeur(valeurCourante);
         oldValeur := valeurCourante;
     end;
     if ErreurLecture
         then showMessage('')
         else EnregistrePointCourant;
     setBoutonAcq;
end end;

begin
      if OscilloForm.isMTX and MesureCB.checked
          then begin
              graphe.EnregistrePointCourant;
              setBoutonAcq;
              EnregistreEdit.setFocus;
          end
          else DemandeEtEnregistre;
      dataSaved := false;    
end;

procedure TMultimetreForm.OscilloPaint(Sender: TObject);
begin
     Graphe.DrawG(Oscillo.clientRect);
     if OscilloForm.isMTX and MesureCB.checked then Graphe.AfficheCurseur;
end;

procedure TMultimetreForm.UndoBtnClick(Sender: TObject);
begin // Supprimer dernier point 
     with graphe do if NbrePoints>0 then dec(NbrePoints);
     Oscillo.refresh;
     setBoutonAcq;
end;

procedure TMultimetreForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
     Timer.Enabled := false;
     EcritConfig(application.exeName);
     OscilloForm.EnregistreBtn.enabled := true;
     OscilloForm.Measure := false;
     if stopBtn.enabled then stopBtnClick(sender); 
     action := caHide;
end;

procedure TMultimetreForm.RegressiItemClick(Sender: TObject);
begin
     FormDDE.Execute(eFocus)
end;

procedure TMultimetreForm.RegSaveBtnClick(Sender: TObject);
begin
     if ConstanteDlg.showModal=mrOk
        then FormDDE.EnvoieDonneesMult(true);
     newPageCB.itemIndex := 1;
     dataSaved := true;
end;

procedure TMultimetreForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMult(false);
     dataSaved := true;
end;

procedure TMultimetreForm.SetBoutonAcq;
begin
     EnregistreBtn.enabled := (graphe.NbrePoints<MaxVecteurMult);
     UndoBtn.enabled := graphe.NbrePoints>0;
     ResetDataBtn.enabled := graphe.NbrePoints>1;
     StopBtn.enabled := false;
     FileSaveBtn.enabled := graphe.NbrePoints>5;
     ClipSaveBtn.enabled := FileSaveBtn.enabled;
     RegSaveBtn.enabled := FileSaveBtn.enabled;
     Timer.enabled := OscilloForm.isMTX and
                      MesureCB.checked and
                      (graphe.NbrePoints<MaxVecteurMult);
     LabelMesure.visible := false;
     cursor := crDefault;
     if timer.enabled
        then EnregistreBtn.hint := 'Enregistrer le point courant'
        else EnregistreBtn.hint := 'Acqurir et enregistrer'
end;

procedure TMultimetreForm.ResetDataBtnClick(Sender: TObject);
begin
     Graphe.NbrePoints := 0;
     Oscillo.refresh;
     setBoutonAcq;
end;

procedure TMultimetreForm.ChargeConfigItemClick(Sender: TObject);
begin
    SetBoutonAcq;
    if OpenDialogConfig.Execute then LitConfig(OpenDialogConfig.FileName)
end;

procedure TMultimetreForm.LitConfig(const NomFichier : string);
var Ini : TiniFile;
    j : indiceVoieMult;
begin with graphe do begin
       FichierConfig := NomFichier;
       if fichierConfig='' then exit;
       FichierConfig := ChangeFileExt(FichierConfig,extensionMx);
       if not FileExists(FichierConfig) then exit;
       try
       Ini := TiniFile.Create(FichierConfig);
       MesureCB.checked := Ini.ReadBool('Metrix','MESURE',false);
       for j := 0 to NbreVoiesMax do with voie[j] do begin
              Nom := Ini.ReadString('Voie'+IntToStr(j),'Nom',VoieDefaut[j].nom);
              Unite := Ini.ReadString('Voie'+IntToStr(j),'Unite',VoieDefaut[j].unite);
              Signif := Ini.ReadString('Voie'+IntToStr(j),'Signif',VoieDefaut[j].signif);
              Command := ansiString(Ini.ReadString('Voie'+IntToStr(j),'Command',VoieDefaut[j].command));
              CommandMTX := ansiString(Ini.ReadString('Voie'+IntToStr(j),'CommandMtx',VoieDefaut[j].commandMTX));
              Active := Ini.ReadBool('Voie'+IntToStr(j),'Active',VoieDefaut[j].active);
              Positive := Ini.ReadBool('Voie'+IntToStr(j),'Positive',VoieDefaut[j].positive);
              Mini := Ini.ReadFloat('Voie'+IntToStr(j),'Mini',VoieDefaut[j].mini);
              Maxi := Ini.ReadFloat('Voie'+IntToStr(j),'Maxi',VoieDefaut[j].maxi);
              Duree := Ini.ReadInteger('Voie'+IntToStr(j),'Duree',200);
              try
              NumVoie := Ini.ReadInteger('Voie'+IntToStr(j),'Numro',1);
              except
              NumVoie := 1;
              end;
       end;
       setVoies;
       ini.free;
       except
          showMessage('Erreur lecture fichier configuration');
       end;
end end;

procedure TMultimetreForm.SauveConfigItemClick(Sender: TObject);
begin
     SaveDialog.filter := 'Configuration (*.mx)|*.mx';
     SaveDialog.defaultExt := 'mx';
     SaveDialog.title := 'Sauvegarde configuration';
     if saveDialog.Execute then EcritConfig(saveDialog.FileName);
end;

procedure TMultimetreForm.EcritConfig(const NomFichier : string);
var Ini : TiniFile;
    j : indiceVoieMult;
begin with graphe do begin
      FichierConfig := ChangeFileExt(NomFichier,extensionMx);
      try
      Ini := TiniFile.Create(FichierConfig);
      Ini.WriteBool('Metrix','MESURE',MesureCB.checked and OscilloForm.isMTX);
      for j := 0 to NbreVoiesMax do with voie[j] do begin
          Ini.WriteString('Voie'+IntToStr(j),'Nom',nom);
          Ini.WriteString('Voie'+IntToStr(j),'Unite',unite);
          Ini.WriteString('Voie'+IntToStr(j),'Signif',signif);
          Ini.WriteString('Voie'+IntToStr(j),'Command',string(command));
          Ini.WriteString('Voie'+IntToStr(j),'CommandMtx',string(commandMTX));
          Ini.WriteBool('Voie'+IntToStr(j),'Active',active);
          Ini.WriteBool('Voie'+IntToStr(j),'Positive',positive);
          Ini.WriteString('Voie'+IntToStr(j),'Mini',FloatToStr(Mini));
          Ini.WriteString('Voie'+IntToStr(j),'Maxi',FloatToStr(Maxi));
          Ini.WriteInteger('Voie'+IntToStr(j),'Numro',NumVoie);
          Ini.WriteInteger('Voie'+IntToStr(j),'Duree',Duree);          
      end;
      Ini.Free;
      except
      end;
end end;

procedure TMultimetreForm.VoieClick(Sender: TObject);
var j : indiceVoieMult;
begin
     timer.Enabled := false;
     j := (sender as Tcomponent).tag;
     VoiesDlg.voieLue := graphe.voie[j];
     VoiesDlg.ShowModal;
     setVoies;
end;

procedure TMultimetreForm.FormActivate(Sender: TObject);
begin
     OscilloForm.EnregistreBtn.enabled := false;
     OscilloForm.Measure := true;
     Majgb.Visible := OscilloForm.isMTX;
     if OscilloForm.isMTX
        then caption := 'Diagramme de Bode avec oscillo Metrix MTX 3352'
        else caption := 'Diagramme de Bode avec oscillo Metrix 80xx';
     setVoies;
end;

Procedure TMultimetreForm.SetVoies;
var j : indiceVoieMult;
    gamme : string;
begin with graphe do begin
    for j := 0 to NbreVoiesMax do with voie[j] do begin
           if j=0
              then gamme := ''
              else begin
                  if Positive then gamme := ' +' else gamme := ' ';
                  gamme := gamme+strValeur(Maxi);
              end;
           LabelVoie.visible := active;
           LabelVoie.color := couleurVoie[j];
           if active
              then begin
                  if isXP
                     then begin
                        GBvoie.color := clWindow;
                        LabelVoie.font.color := couleurVoie[j];
                        GBvoie.font.color := couleurVoie[j];
                     end
                     else GBvoie.color := couleurVoie[j];
                 GBvoie.Caption := 'CH'+intToStr(numVoie)+' '+Signif+gamme;
              end
              else begin
                GBvoie.Caption := '';
                GBvoie.color := clGray;
                LabelVoie.caption := '';
              end;
    end;
    Timer.enabled := OscilloForm.isMTX and
                     MesureCB.checked and
                     (graphe.NbrePoints<MaxVecteurMult);
end end;

procedure TMultimetreForm.EnregistreEditKeyPress(Sender: TObject;var Key: Char);
begin
     if (key=' ') and enregistreBtn.enabled then
         enregistreBtnClick(sender);
     key := #0;
end;

procedure TMultimetreForm.Retour(Sender: TObject);
begin
  if (graphe.NbrePoints>0) and
     (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
     then SaveItemClick(sender);
  Close;
end;

procedure TMultimetreForm.FormDestroy(Sender: TObject);
begin
     Graphe.Free
end;

procedure TMultimetreForm.GroupBoxFreqClick(Sender: TObject);
begin
      VoieXDlg.voieLue := graphe.voie[0];
      if VoieXDlg.ShowModal=mrOK then begin
           oscillo.Refresh;
           setVoies;
      end;
end;

procedure TMultimetreForm.MesureCBClick(Sender: TObject);
begin
   setBoutonAcq;
   EnregistreEdit.setFocus;
end;

procedure TMultimetreForm.TimerTimer(Sender: TObject);
var i : indiceVoieMult;
    comm : ansiString;
begin with graphe do begin
     erreurLecture := false;
     arretLecture := false;
     stopBtn.Enabled := true;
     LabelErreurLecture.visible := false;
     LabelErreur.visible := false;
     for i := voieX to NbreVoiesMax do with voie[i] do if active then begin
         if OscilloForm.isMTX
            then begin
               comm := 'MEAS:'+CommandMTX+'? INT'+IntToStr(NumVoie);
               if commandMTX='PHAS'
                  then comm := comm+',INT'+IntToStr(NumVoieRef);
               ValeurCourante := OscilloForm.GetFloat(comm,unite);
            end
            else ValeurCourante := OscilloForm.GetFloat('MEAS:'+Command+'? (@'+IntToStr(NumVoie)+')','');
         if isnan(ValeurCourante) then begin
               ValeurCourante := oldValeur;
               LabelVoie.caption := nom+'=???';
               if (unite='') or (unite='Hz') or (unite='s')
                  then begin
                     statusBar.panels[0].Text := 'Moins de deux priodes ?';
                     labelVoie.hint := statusBar.panels[0].Text;
                  end
                  else begin
                     statusBar.panels[NumVoie].Text := 'CH'+intTostr(numvoie)+' sature ?';
                     labelVoie.hint := statusBar.panels[NumVoie].Text;
                  end;
                  Application.ProcessMessages;
                  if arretLecture then begin
                     setBoutonAcq;
                     exit;
                  end;
                  erreurLecture := true;
                  // break;
         end
         else LabelVoie.caption := nom+'='+strValeur(valeurCourante);
     end;
     if ErreurLecture then begin
         statusBar.panels[4].Text := 'Erreur sur la dernire mesure';
         LabelErreur.visible := true;
         StopBtn.enabled := true;
     end // erreurLecture
     else statusBar.panels[4].Text := '';
     if MesureCB.checked and oscilloForm.isMTX then Oscillo.Refresh;
     setBoutonAcq;
end end;

procedure TMultimetreForm.StopBtnClick(Sender: TObject);
begin
     ArretLecture := true;
     MesureCB.Checked := false;
     StopBtn.enabled := false;
end;

end.

