unit Mxvoies;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, iniFiles, dialogs,
  MXgrapheMult;

type
  TVoiesDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    ListeCommande: TListBox;
    NumVoieRG: TRadioGroup;
    GroupBox2: TGroupBox;
    EditMaxi: TEdit;
    Bevel1: TBevel;
    UniteL1: TLabel;
    GroupBox3: TGroupBox;
    EditNom: TEdit;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    NumVoieRefRG: TRadioGroup;
    procedure OKBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListeCommandeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
  private
    ListeVoies : Tlist;
  public
    VoieLue : Tvoie;
    MultimetreOK : boolean;
  end;

var
  VoiesDlg: TVoiesDlg;

implementation

uses Mxmain;

{$R *.DFM}

procedure TVoiesDlg.OKBtnClick(Sender: TObject);
begin
     voieLue.active := true;
     voieLue.NumVoie := NumVoieRG.itemIndex+1;
     voieLue.NumVoieRef := NumVoieRefRG.itemIndex+1;
     if ListeCommande.itemIndex>=0 then
        with Tvoie(ListeVoies[ListeCommande.itemIndex]) do begin
        voieLue.Command := Command;
        voieLue.CommandMTX := CommandMTX;
        voieLue.Signif := Signif;
        voieLue.Unite := Unite;
        voieLue.Nom := EditNom.text;
     end;
     voieLue.Commentaire := EditComm.text;
     try
     voieLue.Maxi := StrToFloat(EditMaxi.text);
     except
     end;
     if (voieLue.Command='PHAS') and (voieLue.Maxi<90) then voieLue.Maxi := 90;
     if voieLue.Positive
        then voieLue.Mini := 0
        else voieLue.Mini := -voieLue.Maxi
end;

procedure TVoiesDlg.FormCreate(Sender: TObject);
var INI : Tinifile;
    listeNom : tStringList;
    v : Tvoie;
    i : integer;
    NomFichier,NomIndex : string;
begin
    ListeVoies := Tlist.Create;
    ListeCommande.clear;
    NomFichier := ChangeFileExt(Application.exeName,'.INI');
    Ini := TiniFile.Create(NomFichier);
    listeNom := TstringList.Create;
    Ini.ReadSectionValues('Index',ListeNom);
    MultimetreOK := ListeNom.count>0;
    if not MultimetreOK then begin
       showMessage('Mode multimtre impossible : Metrix.ini non trouv');
       Ini.Free;
       exit;
    end;
    ListeVoies.Capacity := ListeNom.count;
    for i := 0 to pred(ListeNom.count) do begin
        v := Tvoie.Create;
        NomIndex := ListeNom.values[IntToStr(i)];
        with v do begin
            Nom := Ini.ReadString(NomIndex,'Nom','');
            Unite := Ini.ReadString(NomIndex,'Unite','');
            Command := ansiString(Ini.ReadString(NomIndex,'Command',''));
            CommandMTX := ansiString(Ini.ReadString(NomIndex,'CommandMTX',''));
            Signif := Ini.ReadString(NomIndex,'Signif','');
            Duree := Ini.ReadInteger(NomIndex,'Duree',200);            
            listeCommande.Items.Add(Signif);
            listeVoies.Add(v);
         end;
    end;
    Ini.Free;
end;

procedure TVoiesDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
{
     if oscilloForm.isMTX and (NumVoieRG.items.count=2) then begin
        NumVoieRG.items.Add('CH3');
        NumVoieRG.items.Add('CH4');
     end;
}     
     try
     NumVoieRG.itemIndex := numVoie-1;
     except
         NumVoieRG.ItemIndex := 0;
     end;
     try
     ListeCommande.ItemIndex := ListeCommande.items.indexOf(signif);
     except
         ListeCommande.ItemIndex := 0;
     end;
     EditMaxi.text := FloatToStr(Maxi);
     EditNom.text := nom;
     EditComm.text := commentaire;
end end;

procedure TVoiesDlg.ListeCommandeClick(Sender: TObject);
begin
     UniteL1.caption := Tvoie(ListeVoies[ListeCommande.itemIndex]).Unite;
     EditNom.text := Tvoie(ListeVoies[ListeCommande.itemIndex]).nom;
     NumVoieRefRG.visible := oscilloForm.isMTX and (ListeCommande.itemIndex=2);
end;

procedure TVoiesDlg.FormDestroy(Sender: TObject);
var i : integer;
begin
    for i := 0 to pred(ListeVoies.count) do
        Tvoie(ListeVoies.Items[i]).free;
    ListeVoies.Free;
end;

procedure TVoiesDlg.CancelBtnClick(Sender: TObject);
begin
     voieLue.active := false;
end;

end.
