unit Voiefreq;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin, SysUtils,
  jmmUtil, HPgraphe, FloatEdit;

type
  TVoieXDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    GroupBox5: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox1: TGroupBox;
    GroupBox3: TGroupBox;
    logCB: TCheckBox;
    NumVoieRG: TRadioGroup;
    Memo1: TMemo;
    EditMaxi: TFloatEdit;
    EditMini: TFloatEdit;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure EditMaxiChange(Sender: TObject);
    procedure EditMiniChange(Sender: TObject);
    procedure EditMaxiExit(Sender: TObject);
    procedure EditMiniExit(Sender: TObject);
  private
  public
     voieLue : Tvoie;
  end;

var
  VoieXDlg: TVoieXDlg;

implementation

{$R *.DFM}

procedure TVoieXDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
     EditMini.value := mini;
     EditMaxi.value := maxi;
     NumVoieRG.itemIndex := pred(NumVoie);
     logCB.checked := AxeLog;
end end;

procedure TVoieXDlg.OKBtnClick(Sender: TObject);
begin with voieLue do begin
     NumVoie := succ(NumVoieRG.itemIndex);
     AxeLog := logCB.checked;
     maxi := EditMaxi.value;
     mini := EditMini.value;
end end;

procedure TVoieXDlg.EditMaxiChange(Sender: TObject);
begin
     EditMini.maxValue := EditMaxi.value/10
end;

procedure TVoieXDlg.EditMiniChange(Sender: TObject);
begin
     EditMaxi.minValue := EditMini.value*10
end;

procedure TVoieXDlg.EditMaxiExit(Sender: TObject);
var nombre : string;
    posHz : integer;
begin
     nombre := EditMaxi.text;
     posHz := pos('Hz',Nombre);
     if posHz>0 then delete(nombre,posHz,2);
     EditMaxi.value := strToFloatWin(nombre);
end;

procedure TVoieXDlg.EditMiniExit(Sender: TObject);
var nombre : string;
    posHz : integer;
begin
     nombre := EditMini.text;
     posHz := pos('Hz',Nombre);
     if posHz>0 then delete(nombre,posHz,2);
     EditMini.value := strToFloatWin(nombre);
end;

end.
