unit Voies;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs, IniFiles,
  jmmUtil, HPgraphe;

type
  TVoiesDlg = class(TForm)
    ActiveBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ListeCommande: TListBox;
    NumVoieRG: TRadioGroup;
    GroupBox2: TGroupBox;
    EditMaxi: TEdit;
    Bevel1: TBevel;
    UniteLabel: TLabel;
    GroupBox3: TGroupBox;
    EditNom: TEdit;
    GroupBox1: TGroupBox;
    EditComm: TEdit;
    DesactiveBtn: TBitBtn;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ListeCommandeClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    ListeVoieHP : Tlist;
    ModifNom : boolean;
  public
    VoieLue : Tvoie;
  end;

var
  VoiesDlg: TVoiesDlg;

implementation

uses HPmain;

{$R *.DFM}

procedure TVoiesDlg.ActiveBtnClick(Sender: TObject);
var voieHP : TvoieHP;
begin
     voieLue.Active := sender=ActiveBtn;
     voieLue.NumVoie := succ(NumVoieRG.itemIndex);
     if ListeCommande.itemIndex>=0 then begin
        voieHP := Tvoie(ListeVoieHP[ListeCommande.itemIndex]);
        voieLue.Command := voieHP.Command;
        voieLue.CommandMX := voieHP.CommandMX;
        voieLue.Signif := voieHP.Signif;
        voieLue.Unite := voieHP.Unite;
        voieLue.positive := voieHP.positive;
        voieLue.CalculIncertitude := voieHP.CalculIncertitude;
     end;
     voieLue.Nom := EditNom.text;
     voieLue.Commentaire := EditComm.text;
     voieLue.Maxi := StrToFloatWin(EditMaxi.text);
     if (voieLue.command='PHAS') and (voieLue.Maxi>180) then
         voieLue.Maxi := 180;
     if voieLue.Positive
        then voieLue.Mini := 0
        else voieLue.Mini := -voieLue.Maxi
end;

procedure TVoiesDlg.FormCreate(Sender: TObject);
var ini : Tmeminifile;

Procedure CommandeInterne;
var i : integer;
    liste : TstringList;
begin
    liste := TstringList.create;
    for i := 0 to NsauveCommande do
        liste.add(sauveCommande[i]);
    ini.setStrings(liste);
    liste.Free;
end; { CapteursAutoInterne }

var listeNom : tStringList;
    VoieHP : TvoieHP;
    i : integer;
    NomFichier,NomIndex : string;
begin
    ListeVoieHP := Tlist.Create;
    ListeCommande.clear;
    NomFichier := ChangeFileExt(Application.exeName,'.INI');
    if not FileExists(NomFichier) then begin
       showMessage('Impossible : '+NomFichier+' non trouv');
       halt;
    end;
    Ini := TMeminiFile.Create(NomFichier);
    listeNom := TstringList.Create;
    Ini.ReadSections(ListeNom);
    if ListeNom.count=0 then begin
       showMessage('Impossible : '+NomFichier+' endommag');
       ini.free;
       halt;
    end;
    for i := 0 to pred(ListeNom.count) do begin
        NomIndex := ListeNom[i];
        if (NomIndex='COM') or
           (NomIndex='Index') or
           (NomIndex='HP54600') or
           (NomIndex='Constante') or
           (pos('Voie',nomIndex)=1) then continue;
        voieHP := TvoieHP.Create;
        with voieHP do begin
            Nom := Ini.ReadString(NomIndex,'Nom','');
            Unite := Ini.ReadString(NomIndex,'Unite','');
            Command := Ini.ReadString(NomIndex,'Command','');
            CommandMX := Ini.ReadString(NomIndex,'CommandMX','');
            Signif := Ini.ReadString(NomIndex,'Signif','');
            Positive := Ini.ReadBool(NomIndex,'Positive',true);
            CalculIncertitude := TcalculIncertitude(Ini.ReadInteger(NomIndex,'Incertitude',0));
            Maxi := Ini.ReadFloat(NomIndex,'Maxi',maxi);
            If positive then mini := 0 else mini := -maxi;
            listeCommande.Items.Add(Signif);
            listeVoieHP.Add(voieHP);
         end;
    end;
    Ini.Free;
    ListeNom.Free;
end;

procedure TVoiesDlg.FormActivate(Sender: TObject);
begin with voieLue do begin
     NumVoieRG.itemIndex := pred(numVoie);
     try
     ModifNom := false;
     ListeCommande.ItemIndex := ListeCommande.items.indexOf(signif);
     except
         ListeCommande.ItemIndex := 0;
     end;
     ModifNom := true;
     EditMaxi.text := FloatToStr(Maxi);
     EditNom.text := nom;
     EditComm.text := commentaire;
     UniteLabel.caption := unite;
end end;

procedure TVoiesDlg.ListeCommandeClick(Sender: TObject);
var voieHP : TvoieHP;
    oldUnite : string;
begin
     voieHP := TvoieHP(ListeVoieHP[ListeCommande.itemIndex]);
     oldUnite := UniteLabel.caption;
     UniteLabel.caption := voieHP.Unite;
     if ModifNom and (oldUnite<>voieHP.Unite) then begin
        EditNom.text := voieHP.Nom;
        if (EditNom.text<>'f') and (EditNom.text<>phi)
            then EditNom.text := EditNom.text + IntToStr(succ(NumVoieRG.ItemIndex));
        EditMaxi.text := FloatToStr(voieHP.Maxi);
     end;
end;

procedure TVoiesDlg.FormDestroy(Sender: TObject);
begin
    ListeVoieHP.Clear;
    ListeVoieHP.Free
end;

end.
